package com.mcwl.web.controller.resource;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.security.AlgorithmParameters;
import java.util.Base64;

/**
 * @author DaiZibo
 * @date 2025/1/25
 * @apiNote
 */

public class FileEncryptDecryptUtil {

    private static final String ALGORITHM = "AES/CBC/PKCS5Padding";
    private static final String TRANSFORMATION = "AES";
    private static final String KEY = "iamkeyeeddzasdfs"; // 实际应用中应使用更安全的密钥生成方式
    private static byte[] SAVED_IV; // 静态变量存储IV，确保解密时可访问

    public static void main(String[] args) throws Exception {
// 示例：加密文件
        encryptFile("D:\\ASE\\encryption\\测试文件1.txt", "D:\\ASE\\decode\\加密测试文件1.txt");
// 解密文件
//        decryptFile("D:\\Temp\\test\\test\\caaaa", "D:\\Temp\\test\\test\\日报.xlsx");
    }

    public static void encryptFile(String sourcePath, String encryptedPath) throws Exception {
        Cipher cipher = initCipher(Cipher.ENCRYPT_MODE);
        try (FileInputStream fis = new FileInputStream(sourcePath);
             FileOutputStream fos = new FileOutputStream(encryptedPath);
             CipherOutputStream cos = new CipherOutputStream(fos, cipher)) {
            byte[] buffer = new byte[1024];
            int read;
            while ((read = fis.read(buffer)) != -1) {
                cos.write(buffer, 0, read);
            }
        }
        System.out.println("加密完成");
    }

    public static void decryptFile(String encryptedPath, String decryptedPath) throws Exception {
        Cipher cipher = initCipher(Cipher.DECRYPT_MODE);
        try (FileInputStream fis = new FileInputStream(encryptedPath);
             CipherInputStream cis = new CipherInputStream(fis, cipher);
             FileOutputStream fos = new FileOutputStream(decryptedPath)) {
            byte[] buffer = new byte[1024];
            int read;
            while ((read = cis.read(buffer)) != -1) {
                fos.write(buffer, 0, read);
            }
        }
        System.out.println("解密完成");
    }

    private static Cipher initCipher(int mode) throws Exception {
        Cipher cipher = Cipher.getInstance(ALGORITHM);
        SecretKey secretKey = new SecretKeySpec(KEY.getBytes(), TRANSFORMATION);
        if (mode == Cipher.ENCRYPT_MODE && SAVED_IV == null) {
            cipher.init(mode, secretKey);
            AlgorithmParameters params = cipher.getParameters();
            SAVED_IV = params.getParameterSpec(IvParameterSpec.class).getIV();
            System.out.println("Generated IV: " + Base64.getEncoder().encodeToString(SAVED_IV));
        } else {
            cipher.init(mode, secretKey, new IvParameterSpec(SAVED_IV));
        }
        return cipher;
    }
}
